<?php
define("THIS_FILE", "setup.php");

error_reporting(E_ALL ^ E_NOTICE);
set_time_limit(600);

require_once("../../../config/config.inc.php");
require_once("DbConnection.inc.php");
$DB = new DbConnection(DB_HOST, DB_USER, DB_PASSWD, DB_NAME);
require_once("KDbTools.inc.php");
require_once("../../../admin/MainAdminUI.inc.php");
require_once("autoloader.inc.php");
autoloader::init();

CWFTools::replaceHTMLChars($_POST);
$menu = new MainAdminUI($DB, false);
require_once("data.inc.php");

function findeKategorie($search) {
  global $KATEGORIEN;
  if(is_numeric($search)) {
    foreach ($KATEGORIEN as $kategorieId => $kategorie)
      if($search==$kategorie[1]) return $kategorieId;
  }
  else {
    foreach ($KATEGORIEN as $kategorieId => $kategorie)
      if($search==$kategorie[0]) return $kategorieId;
  }
}

if ($menu->writeHeader(THIS_FILE, "KDb Setup", "")) {
  if(isset($_POST['kdb_submit']) && $_POST['kdb_submit']) {
    $oldDbPrefix = "";
    if(isset($_POST['import_kdb2']) && $_POST['import_kdb2'] && $_POST['db_name_old']) {
      $oldDbPrefix = $_POST['db_name_old'].".".$_POST['kdb_table_prefix_old'];
    }
    ////////////////////////////////////////////////////////////////////////////////
    // Rassen
    $result = $DB->query("CREATE TABLE IF NOT EXISTS pcg2_rassen (
        rasse_id int unsigned NOT NULL AUTO_INCREMENT,
        rasse text,
        lp_start tinyint unsigned NOT NULL,
        lp_max tinyint unsigned NOT NULL,
        mp_start tinyint unsigned NOT NULL,
        xp_start tinyint unsigned NOT NULL,
        PRIMARY KEY (rasse_id)
    );");
    if ($result) { echo "&nbsp;&nbsp;- erstelle Tabelle".": 'pcg2_rassen'.<br>\n"; }
    else { echo "&nbsp;&nbsp;<b>- Fehler beim Erstellen der Tabelle</b>"." 'pcg2_rassen'<br>\n"; $error = 1; }
    
    $sql = "INSERT INTO pcg2_rassen(rasse_id, rasse, lp_start, lp_max, mp_start, xp_start) VALUES\n";
    $sqlIns = array();
    foreach($RASSE as $rasseId => $rasse)
      $sqlIns[] = "('$rasseId', '$rasse', '{$LP_START[$rasseId]}', '{$LP_MAX[$rasseId]}', '{$MP_START[$rasseId]}', '".(($rasseId==1) ? "22" : "20")."')";
    $sql .= implode(",\n", $sqlIns).";";
    $DB->query($sql);


    ////////////////////////////////////////////////////////////////////////////////
    // Götter
    $result = $DB->query("CREATE TABLE IF NOT EXISTS pcg2_goetter (
        gottheit_id int unsigned NOT NULL AUTO_INCREMENT,
        gottheit text,
        PRIMARY KEY (gottheit_id)
    );");
    if ($result) { echo "&nbsp;&nbsp;- erstelle Tabelle".": 'pcg2_goetter'.<br>\n"; }
    else { echo "&nbsp;&nbsp;<b>- Fehler beim Erstellen der Tabelle</b>"." 'pcg2_goetter'<br>\n"; $error = 1; }
    $sql = "INSERT INTO pcg2_goetter(gottheit_id, gottheit) VALUES\n";
    $sqlIns = array();
    foreach($GOETTER as $gottId => $gott)
      $sqlIns[] .= "('$gottId', '$gott')";
    $sql .= implode(",\n", $sqlIns).";";
    $DB->query($sql);


    ////////////////////////////////////////////////////////////////////////////////
    // Kategorien
    $result = $DB->query("CREATE TABLE IF NOT EXISTS pcg2_kategorien (
        kategorie_id int unsigned NOT NULL AUTO_INCREMENT,
        kategorie text,
        PRIMARY KEY (kategorie_id)
    );");
    if ($result) { echo "&nbsp;&nbsp;- erstelle Tabelle".": 'pcg2_kategorien'.<br>\n"; }
    else { echo "&nbsp;&nbsp;<b>- Fehler beim Erstellen der Tabelle</b>"." 'pcg2_kategorien'<br>\n"; $error = 1; }

    $KATEGORIEN = array(
        1=>array("Nachteil", NACHTEIL),
        2=>array("Kampf", KAMPF),
        3=>array("Allgemein", ALLGEMEIN),
        4=>array("Magie", MAGIE),
        5=>array("Artefaktmagie", ARTEFAKTMAGIE),
        6=>array("Bardenmagie", BARDENMAGIE),
        7=>array("Klerikalmagie", KLERIKALMAGIE),
        8=>array("Runenmagie", RUNENMAGIE),
        9=>array("Schamanismus", SCHAMANISMUS),
        10=>array("Schwarze Magie", SCHWARZE_MAGIE),
        11=>array("Weiße Magie", WEISSE_MAGIE),
        12=>array("Zauberei", ZAUBEREI),
        13=>array("Alchemie", ALCHEMIE),
        14=>array("Pharmazie", PHARMAZIE),
        15=>array("Körperlich", 0),
        16=>array("Psychischer Defekt", 0),
        17=>array("Schatten der Vergangenheit", 0),
        18=>array("Verflucht", 0),
        19=>array("Arzneien", 0),
        20=>array("Drogen", 0),
        21=>array("Gifte", 0)
    );

    $sql = "INSERT INTO pcg2_kategorien(kategorie_id, kategorie) VALUES\n";
    $sqlIns = array();
    foreach($KATEGORIEN as $kategorieId => $kategorie)
      $sqlIns[] .= "('$kategorieId', '{$kategorie[0]}')";
    $sql .= implode(",\n", $sqlIns).";";
    $DB->query($sql);


    ////////////////////////////////////////////////////////////////////////////////
    // Fertigkeiten
    $result = $DB->query("CREATE TABLE IF NOT EXISTS pcg2_fertigkeiten (
        fertigkeit_id int unsigned NOT NULL AUTO_INCREMENT,
        fertigkeit text,
        kategorie_id int unsigned,
        unterkategorie_id int unsigned,
        max_stufe tinyint unsigned,
        voraussetzungen text,
        voraussetzungen_text text,
        aktionen text,
        PRIMARY KEY (fertigkeit_id),
        INDEX kategorie_id (kategorie_id)
    );");
    if ($result) { echo "&nbsp;&nbsp;- erstelle Tabelle".": 'pcg2_fertigkeiten'.<br>\n"; }
    else { echo "&nbsp;&nbsp;<b>- Fehler beim Erstellen der Tabelle</b>"." 'pcg2_fertigkeiten'<br>\n"; $error = 1; }

    $sql = "INSERT INTO pcg2_fertigkeiten(fertigkeit_id, fertigkeit, kategorie_id, unterkategorie_id, max_stufe) VALUES\n";
    $sqlIns = array();
    foreach($FERTIGKEITEN as $fertigkeitId => $fertigkeit) {
      if($fertigkeit[F_GRUPPE]<0) continue;

      if(!is_array($fertigkeit[F_EP])) {
        $unterkategorie = findeKategorie($fertigkeit[F_NAME]);
        continue;
      }
      switch($fertigkeit[F_GRUPPE]) {
        case NACHTEIL:
        case PHARMAZIE:
          $sqlIns[] = "('$fertigkeitId', '{$fertigkeit[F_NAME]}', '".findeKategorie($fertigkeit[F_GRUPPE])."', '$unterkategorie', '{$fertigkeit[F_MAX]}')";
          break;
        default:
          if($fertigkeitId==214) {
            $sqlIns[] = "('$fertigkeitId', '{$fertigkeit[F_NAME]}', '".findeKategorie($fertigkeit[F_GRUPPE])."', null, '1')";
            $sqlIns[] = "('372', '{$fertigkeit[F_NAME]} 2', '".findeKategorie($fertigkeit[F_GRUPPE])."', null, '1')";
            $sqlIns[] = "('373', '{$fertigkeit[F_NAME]} 3', '".findeKategorie($fertigkeit[F_GRUPPE])."', null, '1')";
          }
          else
            $sqlIns[] = "('$fertigkeitId', '{$fertigkeit[F_NAME]}', '".findeKategorie($fertigkeit[F_GRUPPE])."', null, '{$fertigkeit[F_MAX]}')";
      }
    }
    $sql .= implode(",\n", $sqlIns).";";
    $DB->query($sql);

    $sql = "UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'121\\']', voraussetzungen_text='Stehlen' WHERE fertigkeit_id='21';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'71\\']||\$f[\\'72\\']', voraussetzungen_text='Kurze Waffen oder Lange Waffen' WHERE fertigkeit_id='67';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'71\\']||\$f[\\'72\\']||\$f[\\'77\\']||\$f[\\'87\\']', voraussetzungen_text='Kurze Waffen oder Lange Waffen oder Stangenwaffen oder Zweihändige Waffen' WHERE fertigkeit_id='68';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'79\\']', voraussetzungen_text='Waffenspezialisierung (Fernkampf)' WHERE fertigkeit_id=74;
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'71\\']&&\$f[\\'72\\']&&\$f[\\'77\\']&&\$f[\\'87\\']&&\$f[\\'80\\']>2', voraussetzungen_text='Kurze Waffen, Lange Waffen, Stangenwaffen, Zweihändige Waffen und 3 Waffenspezialisierungen' WHERE fertigkeit_id=78;
    UPDATE pcg2_fertigkeiten SET fertigkeit='Waffenspezialist (Fernkampf)', max_stufe=9, voraussetzungen='\$f[\\'69\\']||\$f[\\'76\\']||\$f[\\'86\\']', voraussetzungen_text='Blasrohr, Sehenwaffen oder Wurfwaffen' WHERE fertigkeit_id=79;
    UPDATE pcg2_fertigkeiten SET fertigkeit='Waffenspezialist (Nahkampf)', max_stufe=9, voraussetzungen='\$f[\\'71\\']||\$f[\\'72\\']||\$f[\\'77\\']||\$f[\\'87\\']', voraussetzungen_text='Kurze Waffen, Lange Waffen, Stangenwaffen oder Zweihändige Waffen' WHERE fertigkeit_id=80;
    DELETE FROM pcg2_fertigkeiten WHERE fertigkeit_id IN (81, 82, 83, 84, 85);
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'112\\']||\$f[\\'113\\']||\$f[\\'114\\']||\$f[\\'115\\']||\$f[\\'116\\']||\$f[\\'117\\']||\$f[\\'118\\']||\$f[\\'119\\']', voraussetzungen_text='Schreiben/Lesen' WHERE fertigkeit_id='88';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'112\\']||\$f[\\'113\\']||\$f[\\'114\\']||\$f[\\'115\\']||\$f[\\'116\\']||\$f[\\'117\\']||\$f[\\'118\\']||\$f[\\'119\\']', voraussetzungen_text='Schreiben/Lesen' WHERE fertigkeit_id='91';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'112\\']||\$f[\\'113\\']||\$f[\\'114\\']||\$f[\\'115\\']||\$f[\\'116\\']||\$f[\\'117\\']||\$f[\\'118\\']||\$f[\\'119\\']', voraussetzungen_text='Schreiben/Lesen' WHERE fertigkeit_id='94';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'71\\']', voraussetzungen_text='Kurze Waffen' WHERE fertigkeit_id='103';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'102\\']<4||\$f[\\'346\\']', voraussetzungen_text='Medizin 4: Pharmazie, Aquae Vitae' WHERE fertigkeit_id='102';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'102\\']>=3 && \$f[\\'106\\']', voraussetzungen_text='Medizin 3, Pharmazie' WHERE fertigkeit_id='104';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'102\\']', voraussetzungen_text='Medizin' WHERE fertigkeit_id='106';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'121\\']', voraussetzungen_text='Stehlen' WHERE fertigkeit_id='122';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'88\\']&&\$f[\\'130\\']&&\$f[\\'111\\']&&\$f[\\'135\\']', voraussetzungen_text='Alchemie, Runen schreiben, Schmieden und Zauberei' WHERE fertigkeit_id='124';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='(\$f[\\'112\\']||\$f[\\'113\\']||\$f[\\'114\\']||\$f[\\'115\\']||\$f[\\'116\\']||\$f[\\'117\\']||\$f[\\'118\\']||\$f[\\'119\\'])&&!\$f[\\'127\\']', voraussetzungen_text='Schreiben/Lesen, keine Klerikalmagie' WHERE fertigkeit_id='126';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='(\$f[\\'112\\']||\$f[\\'113\\']||\$f[\\'114\\']||\$f[\\'115\\']||\$f[\\'116\\']||\$f[\\'117\\']||\$f[\\'118\\']||\$f[\\'119\\'])&&!\$f[\\'126\\']&&!\$f[\\'132\\']&&!\$f[\\'135\\']&&\$g>1', voraussetzungen_text='Schreiben/Lesen, eine Gottheit, keine andere Magieform' WHERE fertigkeit_id='127';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'112\\']||\$f[\\'113\\']||\$f[\\'114\\']||\$f[\\'115\\']||\$f[\\'116\\']||\$f[\\'117\\']||\$f[\\'118\\']||\$f[\\'119\\']', voraussetzungen_text='Schreiben/Lesen' WHERE fertigkeit_id='129';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'129\\']', voraussetzungen_text='Runenkenntnis' WHERE fertigkeit_id='130';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'130\\']&&\$f[\\'135\\']', voraussetzungen_text='Runen schreiben und Zauberei' WHERE fertigkeit_id='131';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'56\\']&&!\$f[\\'127\\']', voraussetzungen_text='Magiefokus, keine Klerikalmagie' WHERE fertigkeit_id='132';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'135\\']&&\$f[\\'2\\']&&!\$f[\\'134\\']', voraussetzungen_text='Zauberei und Ausgezehrt, keine Weiße Magie' WHERE fertigkeit_id='133';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'135\\']&&!\$f[\\'133\\']', voraussetzungen_text='Zauberei, keine Schwarze Magie' WHERE fertigkeit_id='134';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='(\$f[\\'112\\']||\$f[\\'113\\']||\$f[\\'114\\']||\$f[\\'115\\']||\$f[\\'116\\']||\$f[\\'117\\']||\$f[\\'118\\']||\$f[\\'119\\'])&&!\$f[\\'127\\']', voraussetzungen_text='Schreiben/Lesen, keine Klerikalmagie' WHERE fertigkeit_id='135';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'127\\']&&\$g==8', voraussetzungen_text='Klerikalmagie/Varkaz' WHERE fertigkeit_id='369';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='\$f[\\'127\\']&&\$g==8', voraussetzungen_text='Klerikalmagie/Varkaz' WHERE fertigkeit_id='370';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6, 7))' WHERE fertigkeit_id='161';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6, 7, 8))' WHERE fertigkeit_id='162';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3, 5))' WHERE fertigkeit_id='163';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(5, 6, 7))' WHERE fertigkeit_id='164';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3, 4, 6, 7, 8))' WHERE fertigkeit_id='165';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2))' WHERE fertigkeit_id='166';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3, 5, 6))' WHERE fertigkeit_id='167';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(4, 5, 6, 7, 8))' WHERE fertigkeit_id='168';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(8))' WHERE fertigkeit_id='169';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 4, 6, 7, 8))' WHERE fertigkeit_id='170';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3, 8))' WHERE fertigkeit_id='171';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(7))' WHERE fertigkeit_id='172';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6, 7, 8))' WHERE fertigkeit_id='173';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(7))' WHERE fertigkeit_id='174';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(4))' WHERE fertigkeit_id='175';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(5))' WHERE fertigkeit_id='176';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2))' WHERE fertigkeit_id='177';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(7))' WHERE fertigkeit_id='178';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6))' WHERE fertigkeit_id='179';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5))' WHERE fertigkeit_id='180';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(8))' WHERE fertigkeit_id='181';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5))' WHERE fertigkeit_id='182';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3))' WHERE fertigkeit_id='183';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(5, 6, 7, 8))' WHERE fertigkeit_id='184';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6, 7, 8))' WHERE fertigkeit_id='185';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(5, 6, 7, 8))' WHERE fertigkeit_id='186';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(8))' WHERE fertigkeit_id='187';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(4, 6, 7))' WHERE fertigkeit_id='188';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(4, 6, 7))' WHERE fertigkeit_id='189';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6, 7, 8))' WHERE fertigkeit_id='190';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 7))' WHERE fertigkeit_id='191';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5))' WHERE fertigkeit_id='192';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2))' WHERE fertigkeit_id='193';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5))' WHERE fertigkeit_id='194';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5))' WHERE fertigkeit_id='195';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6, 7))' WHERE fertigkeit_id='196';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(8))' WHERE fertigkeit_id='197';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6))' WHERE fertigkeit_id='198';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3, 6, 7))' WHERE fertigkeit_id='199';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2))' WHERE fertigkeit_id='200';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2))' WHERE fertigkeit_id='201';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6, 7, 8))' WHERE fertigkeit_id='202';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6, 7))' WHERE fertigkeit_id='203';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6, 7, 8))' WHERE fertigkeit_id='204';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3, 7))' WHERE fertigkeit_id='205';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3, 6))' WHERE fertigkeit_id='206';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(8))' WHERE fertigkeit_id='207';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(4))' WHERE fertigkeit_id='208';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6))' WHERE fertigkeit_id='209';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 6, 7, 8))' WHERE fertigkeit_id='210';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3, 4))' WHERE fertigkeit_id='211';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5))' WHERE fertigkeit_id='212';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 4))' WHERE fertigkeit_id='213';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6, 7))' WHERE fertigkeit_id='214';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6))' WHERE fertigkeit_id='215';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6, 7, 8))' WHERE fertigkeit_id='216';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 4, 5, 8))' WHERE fertigkeit_id='217';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6, 7, 8))' WHERE fertigkeit_id='218';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6, 7, 8))' WHERE fertigkeit_id='219';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6, 7))' WHERE fertigkeit_id='220';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3))' WHERE fertigkeit_id='221';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6, 7, 8))' WHERE fertigkeit_id='222';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3))' WHERE fertigkeit_id='223';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 4, 5, 6, 7, 8))' WHERE fertigkeit_id='224';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 5))' WHERE fertigkeit_id='225';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 8))' WHERE fertigkeit_id='226';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 6, 7, 8))' WHERE fertigkeit_id='227';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 4, 8))' WHERE fertigkeit_id='228';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(3))' WHERE fertigkeit_id='229';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(7))' WHERE fertigkeit_id='230';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(5))' WHERE fertigkeit_id='231';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(2, 3, 4, 5, 8))' WHERE fertigkeit_id='371';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6, 7))&&\$f[\\'214\\']' WHERE fertigkeit_id='372';
    UPDATE pcg2_fertigkeiten SET voraussetzungen='in_array(\$g, array(6, 7))&&\$f[\\'372\\']' WHERE fertigkeit_id='373';";
    foreach(explode("\n", $sql) as $s) {
      $DB->query($s);
    }

    $result = $DB->query("CREATE TABLE IF NOT EXISTS pcg2_fertigkeiten_ep (
        fertigkeit_id int unsigned,
        rasse_id int unsigned,
        ep tinyint,
        PRIMARY KEY (fertigkeit_id, rasse_id)
    );");
    if ($result) { echo "&nbsp;&nbsp;- erstelle Tabelle".": 'pcg2_fertigkeiten_ep'.<br>\n"; }
    else { echo "&nbsp;&nbsp;<b>- Fehler beim Erstellen der Tabelle</b>"." 'pcg2_fertigkeiten_ep'<br>\n"; $error = 1; }
    $sql = "INSERT INTO pcg2_fertigkeiten_ep(fertigkeit_id, rasse_id, ep) VALUES\n";
    $sqlIns = array();
    foreach($FERTIGKEITEN as $fertigkeitId => $fertigkeit) {
      if($fertigkeit[F_GRUPPE]<0) continue;
      if(!is_array($fertigkeit[F_EP])) continue;

      if($fertigkeitId==214) {
        foreach($fertigkeit[F_EP] as $rasseId => $ep) {
          $sqlIns[] = "('$fertigkeitId', '".($rasseId+1)."', '$ep')";
          $sqlIns[] = "('372', '".($rasseId+1)."', '".($ep+1)."')";
          $sqlIns[] = "('373', '".($rasseId+1)."', '".($ep+2)."')";
        }
      }
      else
        foreach($fertigkeit[F_EP] as $rasseId => $ep)
          $sqlIns[] = "('$fertigkeitId', '".($rasseId+1)."', '$ep')";
    }
    $sql .= implode(",\n", $sqlIns).";";
    $DB->query($sql);
    $DB->query("DELETE FROM pcg2_fertigkeiten_ep WHERE fertigkeit_id IN (81, 82, 83, 84, 85);");

    $result = $DB->query("CREATE TABLE IF NOT EXISTS pcg_laender (
        land_id int unsigned NOT NULL AUTO_INCREMENT,
        land_name text NOT NULL,
        PRIMARY KEY (land_id)
    );");
    if ($result) { echo "&nbsp;&nbsp;- erstelle Tabelle".": 'pcg_laender'.<br>\n"; }
    else { echo "&nbsp;&nbsp;<b>- Fehler beim Erstellen der Tabelle</b>"." 'pcg_laender'<br>\n"; $error = 1; }
    if($oldDbPrefix) {
      if ($result) { echo "&nbsp;&nbsp;- importiere Tabelle".": 'pcg_laender'.<br>\n"; }
        $result = $DB->query("INSERT INTO pcg_laender (
            land_id, land_name
        ) SELECT land_id, land_name
          FROM {$oldDbPrefix}pcg_laender
          ORDER BY land_id;");
      
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
    }

    $result = $DB->query("CREATE TABLE IF NOT EXISTS pcg_charaktere (
        charakter_id int unsigned NOT NULL AUTO_INCREMENT,
        user_id int unsigned NOT NULL,
        charakter_name text NOT NULL,
        rasse_id int unsigned,
        gottheit_id int unsigned,
        stand_id int unsigned,
        lp tinyint unsigned,
        mp tinyint unsigned,
        cp tinyint unsigned,
        sp tinyint unsigned,
        groesse smallint unsigned,
        gewicht smallint unsigned,
        haarfarbe text,
        augenfarbe text,
        beruf text,
        kleidung text,
        bes_kennzeichen text,
        land_id int unsigned NOT NULL,
        herkunft text NOT NULL,
        hintergrund text NOT NULL,
        verlauf text,
        spiele text,
        spiele_ep text,
        vermoegen smallint,
        spez_fertigkeiten text,
        artefakte text,
        charakter_bild text,
        diebeszinken text,
        ist_tot tinyint,
        deleted tinyint,
        PRIMARY KEY (charakter_id),
        INDEX user_id (user_id)
    );");
    if ($result) { echo "&nbsp;&nbsp;- erstelle Tabelle".": 'pcg_charaktere'.<br>\n"; }
    else { echo "&nbsp;&nbsp;<b>- Fehler beim Erstellen der Tabelle</b>"." 'pcg_charaktere'<br>\n"; $error = 1; }
    if($oldDbPrefix) {
      if ($result) { echo "&nbsp;&nbsp;- importiere Tabelle".": 'pcg_charaktere'.<br>\n"; }
        $result = $DB->query("INSERT INTO pcg_charaktere (
            charakter_id, user_id, charakter_name, rasse_id, gottheit_id, stand_id, 
            lp, mp, cp, sp,
            groesse, gewicht, haarfarbe, augenfarbe, beruf, kleidung,
            bes_kennzeichen, land_id, herkunft, hintergrund, verlauf,
            spiele, spiele_ep, vermoegen, spez_fertigkeiten, artefakte,
            charakter_bild, diebeszinken, ist_tot, deleted
        ) SELECT charakter_id, reg_id, charakter_name, rasse_id, gottheit_id, 0 stand_id, 
            lp, mp, cp, sp,
            groesse, gewicht, haarfarbe, augenfarbe, beruf, kleidung,
            bes_kennzeichen, land_id, herkunft, hintergrund, verlauf,
            spiele, spiele_ep, vermoegen, spez_fertigkeiten, artefakte,
            charakter_bild, diebeszinken, 0 ist_tot, 0 deleted
          FROM {$oldDbPrefix}pcg_charaktere
          ORDER BY charakter_id;");
      
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
    }

    $result = $DB->query("CREATE TABLE IF NOT EXISTS pcg_char_fertigkeiten (
        charakter_id int unsigned NOT NULL,
        fertigkeit_id int unsigned NOT NULL,
        stufe tinyint unsigned NOT NULL,
        immunitaet_id int unsigned,
        INDEX (charakter_id,fertigkeit_id)
    );");
    if ($result) { echo "&nbsp;&nbsp;- erstelle Tabelle".": 'pcg_char_fertigkeiten'.<br>\n"; }
    else { echo "&nbsp;&nbsp;<b>- Fehler beim Erstellen der Tabelle</b>"." 'pcg_char_fertigkeiten'<br>\n"; $error = 1; }
    if($oldDbPrefix) {
      echo "&nbsp;&nbsp;- importiere Tabelle".": 'pcg_char_fertigkeiten'.<br>\n";
      $result = $DB->query("INSERT INTO pcg_char_fertigkeiten (
          charakter_id, fertigkeit_id, stufe, immunitaet_id
      ) SELECT charakter_id, fertigkeit_id, stufe, immunitaet_id
        FROM {$oldDbPrefix}pcg_char_fertigkeiten
        WHERE charakter_id>0
        ORDER BY charakter_id, fertigkeit_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      //Update "Waffenspezialist"
      $result = $DB->query("INSERT INTO pcg_char_fertigkeiten (
           charakter_id, fertigkeit_id, stufe, immunitaet_id
        ) SELECT charakter_id, 879, count(fertigkeit_id), null
          FROM pcg_char_fertigkeiten
          WHERE fertigkeit_id IN (79, 82, 84)
          GROUP BY charakter_id
          ORDER BY charakter_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      $result = $DB->query("INSERT INTO pcg_char_fertigkeiten (
           charakter_id, fertigkeit_id, stufe, immunitaet_id
        ) SELECT charakter_id, 880, count(fertigkeit_id), null
          FROM pcg_char_fertigkeiten
          WHERE fertigkeit_id IN (80, 81, 83, 85)
          GROUP BY charakter_id
          ORDER BY charakter_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      $result = $DB->query("DELETE FROM pcg_char_fertigkeiten WHERE fertigkeit_id IN (79, 80, 81, 82, 83, 84, 85);");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      $result = $DB->query("UPDATE pcg_char_fertigkeiten SET fertigkeit_id=fertigkeit_id-800 WHERE fertigkeit_id>800;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      //Update "Sei verflucht"
      $result = $DB->query("INSERT INTO pcg_char_fertigkeiten (
          charakter_id, fertigkeit_id, stufe, immunitaet_id
      ) SELECT charakter_id, 372, 1, immunitaet_id
        FROM {$oldDbPrefix}pcg_char_fertigkeiten
        WHERE fertigkeit_id=214 AND stufe>1
        ORDER BY charakter_id, fertigkeit_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      $result = $DB->query("INSERT INTO pcg_char_fertigkeiten (
          charakter_id, fertigkeit_id, stufe, immunitaet_id
      ) SELECT charakter_id, 373, 1, immunitaet_id
        FROM {$oldDbPrefix}pcg_char_fertigkeiten
        WHERE fertigkeit_id=214 AND stufe>2
        ORDER BY charakter_id, fertigkeit_id;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
      $result = $DB->query("UPDATE pcg_char_fertigkeiten SET stufe=1 WHERE fertigkeit_id=214;");
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
    }
    
    $result = $DB->query("CREATE TABLE IF NOT EXISTS pcg_reg (
        booking_id int unsigned NOT NULL,
        charakter_id int unsigned NOT NULL,
        end_char_view date,
        PRIMARY KEY (booking_id),
        INDEX charakter_id (charakter_id)
    );");
    if ($result) { echo "&nbsp;&nbsp;- erstelle Tabelle".": 'pcg_reg'.<br>\n"; }
    else { echo "&nbsp;&nbsp;<b>- Fehler beim Erstellen der Tabelle</b>"." 'pcg_reg'<br>\n"; $error = 1; }
    if($oldDbPrefix) {
      if ($result) { echo "&nbsp;&nbsp;- importiere Tabelle".": 'pcg_reg'.<br>\n"; }
        $result = $DB->query("INSERT INTO pcg_reg (booking_id, charakter_id, end_char_view)
          SELECT ub.booking_id, pr.charakter_id, max(pr.end_view)
          FROM {$oldDbPrefix}pcg_reg pr
            JOIN user_booking ub ON (ub.user_id=pr.reg_id AND ub.event_id=pr.event_id)
          GROUP BY ub.booking_id, pr.charakter_id;");
      
      if($DB->errno()) echo "&nbsp;&nbsp;&nbsp;&nbsp;".$DB->error()."<br>\n";
    }
  }
  else {
?>
<h2 class="first">Setup KDb-Phönix-Plugin</h2>

<form id="kdb_form" action="" method="post" enctype="multipart/form-data">
<h3>Daten aus KDb 2 importieren <input type="checkbox" value="1" id="import_kdb2" name="import_kdb2" onClick="if($(this).attr('checked')=='checked') $('#kdb3_import').show(); else $('#kdb3_import').hide();"></h3>

<div id="kdb3_import" style="display:none;">
<p>
  <label for="db_name_old"><?=_("Database name")?>:</label>
  <input type="text" id="db_name_old" name="db_name_old" value="">
</p>
<p>
  <label for="kdb_table_prefix_old"><?=_("Table prefix")?>:</label>
  <input type="text" id="kdb_table_prefix_old" name="kdb_table_prefix_old" value="">
</p>
</div>

<div class="form_controls_bottom">
<p>
  <input type="submit" id="kdb_submit" name="kdb_submit" value="<?=_("Submit")?>">
</p>
</div>
</form>
<?php
  }
}
$menu->writeFooter();
?>
